//Breakout - Stephen Anderson
//Much VLM code was re-used
//Special thanks to Andreas Binner, Mike Fulton, and Yak (for the sprite lib)

#include "proto.h"

int						drawBuffer = 0;
int						numbricks = MAX_BRICKS;
int						num_balls_active = 0;	//Obvious and also used as a score multiplier
int						diff = 0;

mmlColor				clut[27] = {0xeb808000,0xb5808000,0x7e808000,0x47808000,0x10808000,0x31b66e00,0x51f05b00,0x8bc66900,
									0x1d78b800,0x296ff000,0x7276c600,0x51525c00,0x91233700,0xb3465300,0xa5832b00,0xd2921100,
									0xdf894900,0x5d499300,0xaa11a600,0xba2d9c00,0x3dafa500,0x6adeca00,0x8bc6d800,0x72b14900,
									0x92c13600,0xb9a53f00};

//   See "proto.h" for all other includes, function prototypes, and global variables

int main(void)
{
	
	int i, delay;						//Counter variables
	int tmp = 0;						//tmp value holder
	//char buf[SPRINTF_MAX];
	textCode status[50];

	//	Setup audio 
    AUDIOInit();

    Pan.PCMPanLR = 0;
    Pan.PCMPanFB = FRONT;
    Pan.PCMPanUD = 0;

	/* Make sure gl_sysRes stuff is setup */
	mmlPowerUpGraphics( &gl_sysRes );

	/* Now make sure gl_gc stuff is setup */
	mmlInitGC( &gl_gc, &gl_sysRes );	

	/* Setup fonts */
	mmlInitFontContext( &gl_gc, &gl_sysRes, &fc, 4096);

	sysP = mmlAddFont( fc, "sysFont", eT2K, SysFont, 40000 );
	AtariScriptP = mmlAddFont( fc, "AtariScript", eTrueType, AtariScript, 69224 );

	// Point the video hardware at the display buffer
	init_screenbuffers();

	// Start Sprite Rendering Engine 
	// Use MPEs 0,1 and 2 for rendering, 16 pixel slices 
	SPRInit(0,2,16);
	//SPRInit(0,2,16,SPR_FLAG_CLEAR_FAST || SPR_FLAG_DOUBLE_BUFFER);

	// Set sprite library to point at the rendering framebuffer
	SPRSetDestScreen(gl_screenbuffers[drawBuffer].memP, 
					 gl_screenbuffers[drawBuffer].dmaFlags,  
					 0,  0,  SCREENWIDTH-1,  SCREENHEIGHT-1, 
					 kBlack);

	// Install TGA image for the balls
	// NOTE - we could have just used one call to SPRInstallTGAImage, but the code
	// is set up this way to allow for different ball images
	for (i=0; i < MAX_BALLS; i++){
		SPRInstallTGAImage (BallSprite, 1, &(theball[i].Ball), 0x00);
		if (DEBUG){
			theScreen = &gl_screenbuffers[0];
			ClearScreen(theScreen);
			mmlSimpleVideoSetup(&gl_screenbuffers[0], &gl_sysRes, eTwoTapVideoFilter);	//Make sure message gets displayed
			msprintf( status, "Ball [%d] TGA", i );
			DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 115, 0x51F05B00, status);
			msprintf( status, "Width = %02d, Height = %02d", theball[i].Ball.width, theball[i].Ball.height );
			DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 130, 0x51F05B00, status);
			msprintf( status, "Mem pos %d", theball[i].Ball.img );
			DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 145, 0x51F05B00, status);
			_TimeToSleep (5000);	//Pause 15 seconds to display info
		}// If (DEBUG)
		theball[i].BallSpr = SPRCreateSprite (&(theball[i].Ball), 0, 0, 60, 60);
		SPRAddSprite (theball[i].BallSpr, 0, 0, 1, 0x4000, 0x4000, 0x40000002, kBlack, 2);
		theball[i].active = 0;
	}

	// Install TGA image for the balls
	SPRInstallTGAImage (BricksSprite, 1, &BrickMatrix, 0x00);
	if (DEBUG){
		theScreen = &gl_screenbuffers[0];
		ClearScreen(theScreen);
		mmlSimpleVideoSetup(&gl_screenbuffers[0], &gl_sysRes, eTwoTapVideoFilter);	//Make sure message gets displayed
		DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 115, 0x51F05B00, "BrickMatrix TGA");
		msprintf( status, "Width = %02d, Height = %02d", BrickMatrix.width, BrickMatrix.height );
		DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 130, 0x51F05B00, status);
		msprintf( status, "Mem pos %d", BrickMatrix.img );
		DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 145, 0x51F05B00, status);
		_TimeToSleep (5000);	//Pause 15 seconds to display info
	}// If (DEBUG)

	//Set up the bricks - cycles through all 9 brick types
	for (i=0; i< MAX_BRICKS; i++){
		bricks[i].BrickSpr = SPRCreateSprite (&BrickMatrix, (i%9)*64, 0, 64, 48);
	}

	//Add sprite to display list
	SPRInstallTGAImage (PaddleSprite, 1, &(thepaddle.Paddle), 0x00);
	pad = _MemAlloc (4096, 0, kMemSDRAM);
	if (DEBUG){
		theScreen = &gl_screenbuffers[0];
		ClearScreen(theScreen);
		mmlSimpleVideoSetup(&gl_screenbuffers[0], &gl_sysRes, eTwoTapVideoFilter);	//Make sure message gets displayed
		DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 115, 0x51F05B00, "Paddle TGA");
		msprintf( status, "Width = %02d, Height = %02d", thepaddle.Paddle.width, thepaddle.Paddle.height );
		DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 130, 0x51F05B00, status);
		msprintf( status, "Mem pos %d", thepaddle.Paddle.img );
		DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 145, 0x51F05B00, status);
		SPRBlitter(thepaddle.Paddle.img, thepaddle.Paddle.dmaflags, 0, 0, 80, 60,
               gl_screenbuffers[0].memP, gl_screenbuffers[0].dmaFlags,
			   SCREENWIDTH/2, 200, 0x10000, 0x10000, 0,
               0,0,SCREENWIDTH-1,SCREENHEIGHT-1,
               0x40000002, 0);
		_TimeToSleep (10000);	//Pause 15 seconds to display info
	}// If (DEBUG)
	thepaddle.PaddleSpr = SPRCreateSprite (&(thepaddle.Paddle), 0, 0, 80, 5);
	SPRAddSprite (thepaddle.PaddleSpr, 160, 223, 1, (diff == 0 ? 0xC000 : 0x8000), 0x8000, 0x40000002, kBlack, 3);


	//Variable setup
	delay = 0;							//Used for brick animation
	score = 0;
	level = 0;
	lives = 5;
	xpos = SCREENWIDTH/2;
    ypos = SCREENHEIGHT/2;
	//Put these here before calling title,  because title may or may not call ConfigureControl and we need default values
	xspeed = 6;							//DEFAULT - user configurable
	xdeadzone = 24;						//DEFAULT - user configurable

	
	title();							//Display the title screen

	//startgame : We get to this point after pressing "start" from the controller config screen OR pressing A from the menu with start game selected
	//the label is used strictly for commenting purposes in the above mentioned functions (program flow is commented)
	numbricks = level_start();			//Set counter and start level


	for(;;)
	{
		// Set up screen pointer
		theScreen = &gl_screenbuffers[drawBuffer];
		ClearScreen(theScreen);		//Let the sprite library handle this

		MovePaddle ();	

		//"Twinkle" the bricks
		delay ++;
		if (delay == 6 && lives > 0){		//Twinkle bricks every 6th frame (10 times per second)
			for (i=0; i < MAX_BRICKS; i++){
				if (bricks[i].visible == 1){
					tmp = (rand() % 9);		//Random # (between 0 and 9)
					SPRSetSpriteSource ( bricks[i].BrickSpr, (tmp*64), 0, 64, 48);
				}//IF visible
			}//FOR all bricks
			delay = 0;			//Reset
		}//IF delay

		if (num_balls_active == 0 && lives > 0){
			if ( ButtonA(_Controller[1]) ){
				ball_serve(0);
			}
		}

		if (num_balls_active && numbricks){		//Stop ball if num bricks ==0
			move_ball();
		}

		if ( numbricks == 0 ){
			//level_end();
			for (i=0; i < MAX_BALLS; i++){
				theball[i].active = 0;			//Stop ball motion
				SPRSetSpriteXY (theball[i].BallSpr, 0, 0);
			}//FOR

			DebugWS(theScreen->dmaFlags, theScreen->memP, 31, 100, TEXTCOLOR, "Level Complete - Press B to continue");

			if ( ButtonB(_Controller[1]) ){
				numbricks = level_start();		//Set counter and start level
			}//IF ButtonB
		}

		if (lives == 0 ){
			
			for (i=0; i < MAX_BALLS; i++){
				theball[i].active = 0;			//Stop ball motion
				SPRSetSpriteXY (theball[i].BallSpr, 0, 0);
			}//FOR

			DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 130, 0x51F05B00, "      Press Start for New Game");	
			DebugWS(theScreen->dmaFlags, theScreen->memP, 45, 145, TEXTCOLOR,  "         Press Nuon to exit");
			
			tmp += (0x10000 / (fps*1.5));		//Brick should rotate once every 1.5 sec 
			if (tmp > 0x10000) tmp = 0x0;
			for (i=0; i < MAX_BRICKS; i++){
				if (bricks[i].visible == 1){
					SPRSetSpriteRotation( bricks[i].BrickSpr, tmp );
				}//IF visible
			}//FOR all bricks

			if ( ButtonStart(_Controller[1]) ){
				//Reset sprites and game variables
				for (i=0; i < MAX_BRICKS; i++){//Reset all bricks to normal
					SPRSetSpriteRotation( bricks[i].BrickSpr, 0 );
				}//FOR all bricks
				score = 0;
				lives = 5;
				level = 0;
				delay = 0;
				//Cheat - title does not do any buffer swapping
				mmlSimpleVideoSetup(&gl_screenbuffers[drawBuffer], &gl_sysRes, eTwoTapVideoFilter);
				title();						//Re-display title screen
				numbricks = level_start();		//Set counter and start level
			}//IF ButtonStart

			if ( ButtonZ(_Controller[1]) ){
				Credits();
				_BiosExit(0);					//Reset machine (for return to bootloader)
			}//IF ButtonZ
		}

		// Process display list
		SPRSetDestScreen(gl_screenbuffers[drawBuffer].memP, 
						 gl_screenbuffers[drawBuffer].dmaFlags,  
						 0,  0,  SCREENWIDTH-1,  SCREENHEIGHT-1, 
						 kBlack);
		SPRDraw (0,0);

//		I have this down here to save some processing time (gain 10FPS believe it or not!)
		if (DEBUG){
			msprintf( status, "Score = %04d  Level = %02d  FPS =  %02d  Balls = %02d", score, level, fps, numbricks );
			m2dSetRect( &r, 80, 15, 360, 25 );	//MAKE AS SMALL AS POSSIBLE !!!
			mmlSetTextProperties( fc, sysP, 14, TEXTCOLOR, kBlack, eOpaque, 0, 0 );
			mmlSimpleDrawText( fc, &gl_screenbuffers[drawBuffer], status, strlen(status), &r );
		}
		else {
			msprintf( status, "Score = %04d  Level = %02d  Lives =  %01d", score, level, lives );
			m2dSetRect( &r, 115, 15, 295, 25 );	//MAKE AS SMALL AS POSSIBLE !!!
			mmlSetTextProperties( fc, sysP, 14, TEXTCOLOR, kBlack, eOpaque, 0, 0 );
			mmlSimpleDrawText( fc, &gl_screenbuffers[drawBuffer], status, strlen(status), &r );
		}
		//  Disabled due to the new libsprite2
		SPRWait();	//Don't vidsync until display list processing is done
		

		VideoSync();
	}//FOR - main game loop

	_MemFree (pad);			//Release the memory I allocated
     return 0;
}


